{% extends "layout.html" %}
{% block content %}
    <div class="row justify-content-center" style="padding-top:10px;" onload="setUpSocket()">
        <!-- Plant picture and data -->
        <p>
        </p>
        <div class="col-sm-10 justify-content-center">
            <div class="boxShadow">
                <!-- plant picture display -->
                <div style="text-align: center;">
                    <p class="display-4 text-uppercase" style="font-family: 'Raleway', sans-serif;">
                        <u> {{ plant['human_name'] }}</u></p>
                    <img src={{ plant['trefle']['images'][0]['url'] if plant['trefle']['images'][0] else "https://upload.wikimedia.org/wikipedia/commons/6/6e/Diversity_of_plants_image_version_5.png" }} class="card-img-top"
                         width="286" height="286" style="max-width: 286px; max-height: 286px">
                    <hr>
                </div>

                <div style="text-align: center;">
                    <p class="h5 text-uppercase" style="font-family: 'Raleway', sans-serif;">plant live information</p>
                    <hr/>
                    <!-- Plant data -->
                    <table class="table table-borderless">
                        <thead>
                        <tr>
                            <th scope="col"><b></b></th>
                            <th scope="col"><b>Live</b></th>
                            <th scope="col"><b>Recommendations</b></th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr>
                            <td>Soil moisture</td>
                            <td><span id="soil-moisture-{{ plant['plant_id'] }}"></span></td>
                            <td>{{ "Not specfied" }}</td>
                        </tr>
                        <tr>
                            <td>Surrounding temperature</td>
                            <td><span id="temp-{{ plant['plant_id'] }}"></span></td>
                            <td>{{ plant['trefle']['growth']['temperature_minimum']['deg_c'] if plant['trefle']['growth']['temperature_minimum']['deg_c'] != None else "Not specfied" }}</td>
                        </tr>
                        <tr>
                            <td>Fire</td>
                            <td><span id="fire-{{ plant['plant_id'] }}"></span></td>
                            <td>{{ "Not Fire proof" if   plant['trefle']['fire_resistance'] != None else "Fire Proof" }}</td>
                        </tr>
                        <tr>
                            <td>Light percentage</td>
                            <td><span id="light-{{ plant['plant_id'] }}"></span></td>
                            <td>{{ "Likes Sun" if   plant['trefle']['shade_tolerance'] != None else "Likes shade" }}</td>
                        </tr>
                        </tbody>
                    </table>

                    <!-- WATER-->
                    <p class="h5 text-uppercase" style="font-family: 'Raleway', sans-serif;">water storage
                        percentage</p>

                    <!-- Water progress bar-->
                    <div style="padding-left: 15px; padding-right: 15px;">
                        <div class="progress">
                            <div id="water-level-{{ plant['plant_id'] }}"
                                 class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="40"
                                 aria-valuemin="0" aria-valuemax="100" style="width:40%;">
                            </div>
                        </div>

                    </div>
                    <div style="text-align: center; padding-top: 10px;">
                        <a onclick="waterPlant({{ plant['plant_id'] }})">
                            <button class="btn btn-primary my-2 my-sm-0" type="submit">Water Plant</button>
                        </a>
                    </div>
                    <hr/>
                    <p class="h5 text-uppercase" style="font-family: 'Raleway', sans-serif;">Live Data</p>
                    <hr/>
                    <div style="padding-left: 15px; padding-right: 15px;">
                        <canvas id="live-data-chart" width="400" height="400"></canvas>
                    </div>
                    <hr/>
                    <p class="h5 text-uppercase" style="font-family: 'Raleway', sans-serif;">Historic Trends</p>
                    <hr/>
                    <div style="padding-left: 15px; padding-right: 15px;">
                        <canvas id="historic-data-chart" width="400" height="400"></canvas>
                    </div>
                    <hr>
                </div>

            </div>
        </div>
    </div>
    <script>
        {#    Init the js arrays storing the values    #}
        let temperatures = [], soilMoisture = [], light = [];
        let liveChart;
        {# init the histroic data chart using the values from the ajax call#}
        function initializeHistoricDataChart(){
            plant_id = {{ plant['plant_id'] }}
            axios.get(`/plants/historic/${plant_id}`).then((data) => {
                let ctxH = document.getElementById('historic-data-chart').getContext('2d');
                let temp = [], light = [], moisture = [];
                for (let entry of data.data.data){
                    let timestamp = Number(new Date());
                    let date = new Date(entry['time']);
                    temp.push({'x': date, 'y': entry['temp_perc']})
                    light.push({'x': date, 'y': entry['light_perc']})
                    moisture.push({'x': date, 'y': entry['moisture_perc']})
                }
                {# Init the chart using the chart libary #}
                new Chart(ctxH, {
                type: 'line',
                data: {
                    datasets: [{
                        data: moisture,
                        borderColor: "red",
				        fill: false,
                        label: "Moisture"
                    },
                    {
                        data: temp,
                        borderColor: "blue",
				        fill: false,
                        label:"Temp C"
                    },
                    {
                        data: light,
                        borderColor: "green",
				        fill: false,
                        label: "Light"
                    }
                    ]
                },
                options: {
                    responsive: true,
                    title: {
                        display: false,
                    },
                    scales: {
                        xAxes: [{
                            display: true,
                            type: 'time'
                        }],
                        yAxes: [{
                            display: true,
                        }]
                    }
                }
            });

            })
        }
        {# Set up the socket connection to allow for lives values to be shown#}
        function setUpSocket() {
            const socket = io();
            socket.connect('http://127.0.0.1:5000', {query: "foo=bar"});
            socket.on('plant_update', function (msg) {
                if((msg.data[2] == 1)){
                    alert("YOUR PLANT IS ON FIRE")
                }
                updateValues(msg.data[0], msg.data[3], msg.data[4]);
                document.getElementById("soil-moisture-{{ plant['plant_id'] }}").textContent = Math.round(msg.data[0]);
                document.getElementById("fire-{{ plant['plant_id'] }}").textContent = (msg.data[2] == 1) ? "On Fire": "Not on Fire";
                document.getElementById("light-{{ plant['plant_id'] }}").textContent = setLight(msg.data[3]);
                document.getElementById("temp-{{ plant['plant_id'] }}").textContent = msg.data[4];
                document.getElementById("water-level-{{ plant['plant_id'] }}").style.width = `${msg.data[1]}%`;
                document.getElementById("water-level-{{ plant['plant_id'] }}").textContent = `${Math.round(msg.data[1])}%`;

                if (msg.data[1] <= 20) {
                    //document.getElementById("water-level-{{ plant['plant_id'] }}").classList.remove("bd-info");
                    document.getElementById("water-level-{{ plant['plant_id'] }}").classList.add("bg-danger");

                } else {
                    document.getElementById("water-level-{{ plant['plant_id'] }}").classList.remove("bg-danger");
                    //document.getElementById("water-level-{{ plant['plant_id'] }}").classList.add("bg-info");
                }

            });
        }



    {#    Set the light value depending on the numeric value#}
	function setLight(lightValue){
		if(lightValue <= 33){
		 return "Dark"
		}else if (lightValue <=66){
		return "Light"
		}
		else {
		 return "Very Light"
		}
	}
        {# Init the live data chart#}
        function initializeLiveDataChart() {
            let ctxL = document.getElementById('live-data-chart').getContext('2d');
            liveChart = new Chart(ctxL, {
                type: 'line',
                data: {
                    datasets: [{
                        data: temperatures,
                        borderColor: "red",
				        fill: false,
                        label: "Light"
                    },
                    {
                        data: soilMoisture,
                        borderColor: "blue",
				        fill: false,
                        label: "Temp C"
                    },
                    {
                        data: light,
                        borderColor: "green",
				        fill: false,
                        label: "Moisture "
                    }
                    ]
                },
                options: {
                    responsive: true,
                    title: {
                        display: false,
                    },
                    scales: {
                        xAxes: [{
                            display: true,
                            type: 'time'
                        }],
                        yAxes: [{
                            display: true,
                        }]
                    }
                }
            });
        }
        {# Update the values on the page with new values (from the socket)#}
        function updateValues(soilValue, lightValue, temperatureValue) {
            let timestamp = Number(new Date());
            let date = new Date(timestamp);
            let soilEntry = {"x": date.getTime(), "y": temperatureValue}
            let tempEntry = {"x": date.getTime(), "y": lightValue}
            let lightEntry = {"x": date.getTime(), "y": soilValue}

            if (temperatures.length >= 60) {
                temperatures.shift();
            }
            if (soilMoisture.length >= 60) {
                soilMoisture.shift();
            }
            if (light.length >= 60) {
                light.shift();
            }
            temperatures.push(tempEntry);
            soilMoisture.push(soilEntry);
            light.push(lightEntry);
            liveChart.update()
        }

        {# Watering plant ajax call#}
        function waterPlant(plant_id) {
            axios.get(`/plants/water/${plant_id}`)
        }

        {# onload of window funcitons to be called#}
        window.addEventListener('load',
            function () {
                setUpSocket();
                initializeLiveDataChart();
                initializeHistoricDataChart();
            }, false)
        {# stop the socket when the window closes #}
        window.addEventListener("beforeunload", function (e) {
            io().emit('disconnect');
        }, false);

        window.onbeforeunload = closingCode;

        function closingCode() {
            io().emit('disconnect');
        }
    </script>
{% endblock %}
